/*
	$Id: prototype.c,v 1.1 2000/10/03 18:46:03 syl Exp $

	Copyright (C) 1999 Syllabub
	Maroontress Fast Software.
*/

#include <stdio.h>

#include "packet.h"
#include "prototype.h"

void
PrintPrototype(FILE *fp, PacketList *pl)
{
    Type *mem;
    Packet *ptr;

    fprintf(fp,
	    "/*\n"
	    "\tThis file is automatically generated by ximpc.\n"
	    "\tDon't edit this file.\n"
	    "*/\n"
	    "\n"
	    "#include <X11/Xproto.h>\n"
	    "\n"
	    "typedef CARD8 SerializedPacket;\n"
	    "void Free_SerializedPacket(SerializedPacket *);\n"
	    "\n"
	    "typedef CARD8 * STRING8;\n"
	    "typedef xEvent XEVENT;\n"
	    "\n"
	    "typedef struct LIST {\n"
	    "\tstruct LIST *next;\n"
	    "\tvoid *data;\n"
	    "} LIST;\n"
	    "\n"
	    "typedef struct STR {\n"
	    "\tCARD8  len;\n"
	    "\tSTRING8 val;\n"
	    "} STR;\n"
	    "\n"
	    "typedef struct STRING {\n"
	    "\tCARD16  len;\n"
	    "\tSTRING8 val;\n"
	    "\t/* PAD (4 bytes alignment) */\n"
	    "} STRING;\n"
	    "\n"
	    "STRING * Recv_STRING(CARD8 *);\n"
	    "void Free_STRING(STRING *);\n");
    
    for (ptr = pl->top; ptr != NULL; ptr = ptr->next) {
	if (ptr->head == NULL)
	    continue;
	fprintf(fp, "\n" "typedef struct %s {\n", ptr->type);
	for (mem = ptr->head; mem != NULL; mem = mem->next) {
	    if (strcmp(mem->name, "PAD") == 0) {
		fprintf(fp, "\t" "/* PAD (4 bytes alignment) */\n");
	    }
	    else if (mem->mod == Array) {
		fprintf(fp,
			"\t" "struct {\n"
			"\t\t" "CARD16\tnum;\n"
			"\t\t" "%s\t**val;\n"
			"\t" "} %s;\n",
			mem->name, mem->member);
	    }
	    else if (mem->mod == Listof) {
		fprintf(fp, "\t" "LIST\t*%s;\n", mem->member);
	    }
	    else if (mem->mod == Multi) {
		fprintf(fp,
			"\t" "struct {\n"
			"\t\t" "CARD16\tnum;\n"
			"\t\t" "%s\t*val;\n"
			"\t" "} %s;\n",
			mem->name, mem->member);
	    }
	    else {
		fprintf(fp, "\t" "%s\t%s;\n", mem->name, mem->member);
	    }
	}
	fprintf(fp, "} %s;\n\n", ptr->type);
	if (ptr->to_do == Read || ptr->to_do == Both || ptr->to_do == Basic) {
	    fprintf(fp, "%s * Recv_%s(CARD8 *);\n",
		    ptr->type, ptr->type);
	}
	if (ptr->to_do == Write || ptr->to_do == Both || ptr->to_do == Basic) {
	    fprintf(fp, "void Send_%s(%s *, SerializedPacket **, int *);\n",
		    ptr->type, ptr->type);
	}
	fprintf(fp, "void Free_%s(%s *);\n", ptr->type, ptr->type);
	if (ptr->to_do == Basic) {
	    fprintf(fp, "CARD8 * Read_%s(%s *, CARD8 *);\n",
		    ptr->type, ptr->type);
	    fprintf(fp, "CARD8 * Write_%s(%s *, CARD8 *);\n",
		    ptr->type, ptr->type);
	    fprintf(fp, "int Sizeof_%s(%s *);\n", ptr->type, ptr->type);
	}
    }
}
